module signal_2(
    clk    ,
    rst_n  ,
    key_vld,
    key_num,
    dout_vld ,
    dout
    );

    //
    parameter      DATA_W =         6;
    parameter      KEY_W  =         4;

    //źŶ
    input               clk    ;
    input               rst_n  ;
    input               key_vld;
    input [KEY_W-1:0]   key_num;

    //źŶ
    output              dout_vld;
    output[DATA_W-1:0]  dout   ;

    //źreg
	 reg                 dout_vld;
    reg   [DATA_W-1:0]  dout   ;

    //мź
    reg   [DATA_W-1:0]  dout_tmp;

    //dout_vld
    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            dout_vld <= 0;
        end
        else begin
            dout_vld <= key_vld;
        end
    end

    //dout_tmp
    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            dout_tmp <= 0;
        end
        else if(key_vld && key_num==0) begin
            if(dout_tmp == 63)begin
                dout_tmp <= 0;
            end
            else begin
                dout_tmp <= dout_tmp + 1;
            end
        end
    end

    //dout
    always  @(posedge clk or negedge rst_n)begin
        if(rst_n==1'b0)begin
            dout <= 0;
        end
        else if(dout_tmp==6 || dout_tmp==43) begin
            dout <= dout_tmp+1;
        end
        else begin
            dout <= dout_tmp;
        end
    end


endmodule

